// -*- mode: c++ -*-
//  copyright (C) 2001 Makoto Onizuka, University of Washington

#if ! defined(__DEPTH2OFFSET_H__)
#define __DEPTH2OFFSET_H__

#include <stdio.h>
#include <iostream>
#include <FileManager.h>
#include "SIndex.hpp"		// to read indexHeader and indexTable

class Depth2offset 
{
protected:
    enum states 
    {
        S_CONSTRUCT = 0,
        S_ACTIVE,		// SIX is created
        S_END_OF_INDEX
    };

    struct indexTable * m_pPath;
    unsigned int	    m_uiMaxDepth;	// static: max depth
    unsigned int	    m_uiMaxRowSize;	// static: max row size
    unsigned int	    m_uiCurrentDepth;	// dynamic
    unsigned int	    m_uiSkipDepth; 	// dynamic: 
				// this is a flag that specifies current 
				// row is match with the input element.
    FileManager	      * m_pSixFile;
    states	            m_state;

public:
    // Depth2offset constructor and destructor.
    Depth2offset(const char * pszXmlFile);
    virtual ~Depth2offset();

    void Init();
    
    void startElement(unsigned int elementID);
    void endElement(unsigned int elementID);

    // We have to consider two cases:
    // [fail skip] /bib/book <- bib/article
    // [success skip] /bib/book[1] 
    bool isAppliable(void) { return (m_state == S_ACTIVE && m_uiSkipDepth == 0); }

    // For fail skip.
    unsigned int failSkip(unsigned int depth);

	// For both fail skip and succeed skip.
    unsigned int skip(unsigned int depth, unsigned int currentAddress);

    unsigned int getRowCount(void) { return m_uiMaxRowSize; }

    // Print out the SIX index.
    void print(void);
};

#endif
