#ifndef __XMLTK_FILESTREAM_H
#define __XMLTK_FILESTREAM_H

class CFileStream : public IFileStream
{
public:
    // *** IUnknownCL methods ***
    CL_STDMETHOD(QueryInterface) (RCLIID riid, void **ppvObj);
    CL_STDMETHOD_(ULONG,AddRef) ();
    CL_STDMETHOD_(ULONG,Release) ();

    // *** IStream methods ***
    CL_STDMETHOD_(long, CopyTo) (IStream *pstm, long cb);
    CL_STDMETHOD_(long, Peek) (void *pv, long cb);
    CL_STDMETHOD_(long, Read) (void *pv, long cb);
    CL_STDMETHOD_(int, ReadChar) ();
    CL_STDMETHOD_(int, Seek) (long offset, int origin);
    CL_STDMETHOD_(long, SetSize) (long lsize);
    CL_STDMETHOD_(long, GetSize) ();
    CL_STDMETHOD_(long, Tell) ();
    CL_STDMETHOD_(long, Write) (void *pv, long cb);
    CL_STDMETHOD(WriteChar) (int ch);

    // *** IFileStream methods ***
    CL_STDMETHOD_(int, CloseFile) ();
    CL_STDMETHOD_(FILE*, GetFile) ();
    CL_STDMETHOD(SetFile) (FILE* pfile);
    CL_STDMETHOD_(char*, GetFileName) ();
    CL_STDMETHOD(OpenFile) (char *pszFile, char *pszMode);
    
    // CFileStream constructor and destructor.
    CFileStream();
    virtual ~CFileStream();
    
private:
    
    ULONG m_cRef;
    FILE *m_pfile;
    char *m_pszFile;
};

#endif // __XMLTK_FILESTREAM_H