#ifndef __SAXCLIENT_H
#define __SAXCLIENT_H

#include "Depth2offset.h"

class SAXClient
{
public:
    // SAXClient constructor and destructor.
    SAXClient(ITSAXContentHandler *pch, IParse2TSAX * p, Depth2offset * im);
    virtual ~SAXClient();

    void HandleStartElement(const char * pszName);
    void HandleAttribute(const char * pszName, const char * pszValue);
    void HandleCharacters(const char * pszChars, int cchChars);
    void HandleEndElement(const char * pszName);
    void HandleComment(char *str,int len,char iscont);
    void HandlePI(char *str,int len,char iscont);
    void HandleDOCTYPE(char *str,int len,char iscont);
    void HandleStartCDATA(void);
    void HandleEndCDATA(void);

private:
    ITSAXContentHandler * m_pchOut;
    IParse2TSAX         * m_pXmlParser;
    Depth2offset        * m_pIndexMgr;
};

#endif // __SAXCLIENT_H
