#ifndef __XMLPARSER_H
#define __XMLPARSER_H

#include "saxclient.h"
#define XML_CALL_FROM_CPP
#include "expat.h"
#undef XML_CALL_FROM_CPP
#include "input.hpp"

class XMLParser : public Input
{
public:
    // XMLParser constructor and destructor.
    XMLParser();
    virtual ~XMLParser();

    // This is the actual parsing function.
    void Parse(class SAXClient * pClient);

    // Return the offset in the source file.
    unsigned int GetSrcOffset() { return GetFilePos(); }

    // Skip a certain number of bytes in the source file.
    void SkipReader(unsigned int cbSkip);

private:
    // Input file reader.
    Input * m_pInput;

    // Skip flag.
    bool m_fSkip;

    // Expat XML parser.
    XML_Parser m_pExpatParser;

    // These are the call-back function used by the Expat parser.
    static void XMLCALL StartElement(void *userData, const char *name, const char **atts);
    static void XMLCALL EndElement(void *userData, const char *name);
    static void XMLCALL Characters(void * pUserData, const XML_Char * pszChars, int cchChars);
    static void XMLCALL StartCData(void * pUserData);
    static void XMLCALL EndCData(void * pUserData);
};

#endif // __XMLPARSER_H