#ifndef __XMLTK_DFAFILTER_H
#define __XMLTK_DFAFILTER_H

class CDfaFilter : public IDfaFilter
{
public:
  // *** IUnknownCL methods ***
  CL_STDMETHOD(QueryInterface) (RCLIID riid, void **ppvObj);
  CL_STDMETHOD_(ULONG,AddRef) ();
  CL_STDMETHOD_(ULONG,Release) ();

  // *** ITSAXContentHandler methods ***
  CL_STDMETHOD(startDocument) ();
  CL_STDMETHOD(endDocument) ();
  CL_STDMETHOD(startElement) (XTOKEN xtName);
  CL_STDMETHOD(endElement) (XTOKEN xtName);
  CL_STDMETHOD(attribute) (XTOKEN xtName, char *pszChars, int cchChars);
  CL_STDMETHOD(characters) (char *pszChars, int cchChars);
  CL_STDMETHOD(startCDATA) (void);
  CL_STDMETHOD(endCDATA) (void);

  // *** IDfaFilter methods ***
  CL_STDMETHOD_(Variable*,RegisterQuery) (Variable *pv, const char *psz, bool bEvents, float precedence);
  CL_STDMETHOD_(Variable*,RegisterQuery) (Variable *pv, const char *psz, bool bEvents);
  CL_STDMETHOD(RegisterQueryFile) (const char *psz);

  CDfaFilter(void) : m_pfh(NULL), m_cRef(1), m_iOutputLevel(0)
		   , m_pvCompleteList(NULL), m_fInCDATA(false)
  {
  }

  CL_STDMETHOD_(void, SetHandler) (IFilteredTSAXHandler * pHandler);
  CL_STDMETHOD_(void, SetXmlParser) (IParse2TSAX * pXmlParser) { m_pXmlParser = pXmlParser; }

private:
    
  virtual ~CDfaFilter(){
    if (m_pfh) m_pfh->Release();
  }
    
  Query m_queryMgr;
  IFilteredTSAXHandler *m_pfh;
  ULONG m_cRef;
  int m_iOutputLevel;
  VarPtrArray * m_pvCompleteList;
  IParse2TSAX * m_pXmlParser;
  bool m_fInCDATA;
};

#endif // __XMLTK_DFAFILTER_H
