/************************************************************************
// -*- mode: c++ -*-
//  copyright (C) 2001 Makoto Onizuka, University of Washington
//  $Id: Error.cxx,v 1.1.1.1 2002/05/04 12:53:54 tjgreen Exp $
*************************************************************************/
#include "xmltk.h"
#include "Error.h"

//#ifndef WIN32
//#include <iostream.h>
//#else
//#include <iostream>
//using namespace std;
//#endif

EList::EList(unsigned long size)
{
    m_ulCount = 0;
    m_ulNext  = 0;
    
    m_ulSize = size;
    m_ppList = (ErrItem **) calloc(m_ulSize, sizeof(ErrItem *));
}

unsigned long EList::newItem()
{
    if (m_ppList[m_ulNext] == NULL) 
        return m_ulNext++;
  
    for (unsigned long ulItem = 0 ; ulItem < m_ulSize ; ulItem++)
    {
        if (m_ppList[ulItem] != NULL)
        {
            m_ulNext = ulItem + 1;
            return ulItem;
        }
    }
  
    return m_ulSize;
}

ErrItem * EList::getItem(unsigned long ulPos)
{
    return (ulPos < m_ulSize ? m_ppList[ulPos] : NULL);
}

void EList::setItem(unsigned long ulPos, ErrItem * pItem)
{
    assert(ulPos < m_ulSize);
  
    if (m_ppList[ulPos] == NULL) 
        m_ulCount++; 
//  if (t == NULL){
//    count--;
//   if ((pos > 0)&&(list[pos - 1] != NULL)) next = pos;
//  }
    m_ppList[ulPos] = pItem;
}

_Error::_Error(Base * obj, char * mtd, int code)
{
    m_pErrList = new EList(ERROR_STACK_SIZE);
    m_pErrList->setItem(0, new ErrItem(obj, mtd, code));
}

void _Error::addItem(ErrItem * pItem)
{
    m_pErrList->setItem(m_pErrList->newItem(), pItem);
}

void _Error::Print()
{
    for (unsigned long i = 0 ; i < m_pErrList->getCount() ; i++)
    {
        ErrItem * pItem = m_pErrList->getItem(i);
        cerr << i << "\t";
        cerr << pItem->getMessage() << ", line = " << pItem->getErrcode() << endl;
    }
}