/************************************************************************
// -*- mode: c++ -*-
//  copyright (C) 2001-2002 Makoto Onizuka, University of Washington
//  $Id: Error.h,v 1.1.1.1 2002/05/04 12:53:54 tjgreen Exp $
*************************************************************************/

#if ! defined(__XMLTK_ERR_H__)
#define __XMLTK_ERR_H__
#define ERROR_STACK_SIZE  30

#include <stdlib.h>
#include "Base.h"

class ErrItem {
 public:
  Base	      * lastobj;
  char        * lastmethod;
  int		errcode;

  ErrItem(Base * obj, char * mtd, int code):
    lastobj(obj), lastmethod(mtd), errcode(code) {};
  ~ErrItem() {};
  char * getMessage() {return lastmethod;}
  int    getErrcode() {return errcode;}
};

class EList {
protected:
  unsigned long m_ulSize;
  unsigned long m_ulCount;
  unsigned long m_ulNext;
  ErrItem    **	m_ppList;

public:

    // EList constructor and destructor.
    EList(unsigned long size);
    virtual ~EList() {};

    void    freeSpace() {free(m_ppList);}
    unsigned long newItem();
    ErrItem* getItem(unsigned long pos);
    void 	  setItem(unsigned long pos, ErrItem *);
    unsigned long getSize() {return m_ulSize;}
    unsigned long getCount() {return m_ulCount;}
};

class _Error 
{
protected:
    EList * m_pErrList;

public:
    // _Error constructor and destructor.
    _Error(Base * obj, char * mtd, int code);
    ~_Error(){};

    // Add an error item to the error collection.
    void addItem(ErrItem * pItem);

    // Print out all the messages in the error.
    void Print();
};

#endif /* __XMLTK_ERR_H__ */

